
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error(),RangeList();

#define LEN	1024
#define PV	(size_t)(Cell)(~0)

static int	Check(path,Nx,Ny,cell,pv)
char		*path;
int		Nx,Ny;
Cell		***cell,*pv;
{
	int		x,y,file=1;
	char		msg[LEN];
	unsigned int	ui;

	if (*path!='-') {
	    ReadImageFile(path,&x,&y,NULL,cell,NULL);

	    if (x!=Nx || y!=Ny) {
		(void)sprintf(msg,"%s : bad image size.",path); Error(msg);
	    }
	}
	else {
	    if (sscanf(path+1,"%u",&ui)!=1 || ui>PV) {
		(void)sprintf(msg,"%s : bad pixel value.",path+1); Error(msg);
	    }
	    *pv=(Cell)ui; file=0;
	}
	return file;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,y,x,bps;
	Cell	**cell,**bC,bV,**fC,fV,c,C=0;
	char	pv01[PV+1];

	if (argc!=6)
Error("usage : mask_gray maskTIFF rangeList backTIFF|-PV foreTIFF|-PV newTIFF");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	RangeList(argv[2],PV,pv01);

#define MASK(b,f)	\
	for (y=0; y<Ny; y++) for (x=0; x<Nx; x++) { \
	    if ((c=cell[y][x]=(pv01[cell[y][x]])?f:b)>C) C=c; \
	}

	if (Check(argv[3],Nx,Ny,&bC,&bV))
	    if (Check(argv[4],Nx,Ny,&fC,&fV))
		MASK(bC[y][x],fC[y][x])
	    else
		MASK(bC[y][x],fV)
	else
	    if (Check(argv[4],Nx,Ny,&fC,&fV))
		MASK(bV,fC[y][x])
	    else
		MASK(bV,fV)

	for (bps=1; 1<<bps<=C; bps<<=1) ;

	StoreImageFile(argv[5],Nx,Ny,bps,cell,NULL);

	return 0;
}
